#INCLUDE Foxpro.H
#INCLUDE msOutl9.H
#INCLUDE Xls2outl.H

* PARAMETERS pcPar01, pcPar02, pcPar03, pcPar04, pcPar05, pcPar06, pcPar07, pcPar08, pcPar09


*       Xls2Outl
*
cRelease="Rel. 2.1.1 18.09.2006"              && release of program
cProgram="Xls2Outl"

IF .not.FirstInstance(cProgram)
   MessageBox("Program is already running."+CHR(13)+"This instance will be canceled...",0+16,cProgram)
   QUIT
ENDIF

DO FORM waitwind NAME frmWait WITH "<"+cProgram+">"+CHR(13)+"Application is loading..."

store [] to cCfgFile, cIniFile, cLogFile, cHelpFile, cDataDir, cDSN, cPassword, cLogin
store 60 to nLogFileExpireDays

SetEnvironment(cProgram)		&& std files, SETtings
ON SHUTDOWN do ProgramShutdown

* aAddRow(@aErrTrap, 1429, [RETURN])	&& 1429 OLE IDispatch exception code 4096 from Microsoft Outlook: Dolo k nesouladu typ. Nelze nast parametr. Outlook neme dan etzec pevst...
store .F. to lErr1733, lErr1429, lErr1426, lErr1943, lErr1440, lErr1923
* aAddRow(@aErrTrap, 1733, [store .T. to lErr1733])	&& 1733 Class definition ... is not found.
aAddRow(@aErrTrap, 1426, [store .T. to lErr1426])	&& OLE error code 0x80020006
aAddRow(@aErrTrap, 1429, [store .T. to lErr1429])	&& OLE IDispatch exception code 4096
* aAddRow(@aErrTrap, 1440, [store .T. to lErr1440])	&& OLE exception error: Exception code c0000005. OLE object may be corrupt
* aAddRow(@aErrTrap, 1943, [store .T. to lErr1943])	&& Member ... does not evaluate
aAddRow(@aErrTrap, 1923, [store .T. to lErr1923])	&& Object not found


* ON ERROR
* _SCREEN.Visible=.T.

cINIfile=iif( file(cINIfile), FullPath(cINIfile), ForcePath(cINIfile, JustPath(sys(16, 0))) )

Logging("START "+cRelease)
Logging("Used Params - Common/INIFILE: "+FullPath(cINIfile)+iif(file(cINIfile), " ", " not ")+"present")
Logging("Used Params - Common/CFGFILE: "+FullPath(cCfgfile)+iif(file(cCFGfile), " ", " not ")+"present")
Logging("Used Params - Common/HELPFILE: "+FullPath(cHelpfile)+iif(file(cHELPfile), " ", " not ")+"present")
Logging("Used Params - Common/LogFileExpireDays: ", nLogFileExpireDays)

*cParam01=GetIniPar(cIniFile, "param01", "Common")
*Logging("Used Params - Common/param01: "+cParam01)

*cParam02=GetIniPar(cIniFile, "param02", "Xls2Outl", [Param02])			&& char param
*Logging("Used Params - Xls2Outl/param02: "+cParam02)

*lParam03=InList( Upper(GetIniPar(cIniFile, "param03", "Xls2Outl", [NO])),						;
*					   ".T.", "T", "1", "YES", "Y", "TRUE", "JA", "J", "ANO", "A", "ON" )		&& logical param
*Logging("Used Params - Xls2Outl/param03: "+iif(lParam03, "YES", "NO"))

*nParam04=val(GetIniPar(cIniFile, "param04", "Xls2Outl", [0]))			&& num param
*Logging("Used Params - Xls2Outl/param04: "+Transform(nParam04))

lMinimizeToSysTray=InList( Upper(GetIniPar(cIniFile, "MinimizeToSysTray", "Xls2Outl", [NO])),						;
					   ".T.", "T", "1", "YES", "Y", "TRUE", "JA", "J", "ANO", "A", "ON" )		&& logical param
Logging("Used Params - Xls2Outl/MinimizeToSysTray: "+iif(lMinimizeToSysTray, "YES", "NO"))
lCheckClasses=InList( Upper(GetIniPar(cIniFile, "CheckClasses", cProgram, [YES])),						;
					   ".T.", "T", "1", "YES", "Y", "TRUE", "JA", "J", "ANO", "A", "ON" )		&& kontrola dostupnosti OLE server a CLASS
Logging(mcMSG10, cProgram, "/CheckClasses: ", iif(lCheckClasses, "YES", "NO"))

IF lCheckClasses
***** Kontrola pouzitych OCX a DLL
local array xaClasses(1)
local xcMsg
aFillRow(@xaClasses, 1, [])
aAddRow(@xaClasses, [MSMAPI.MAPISession.1])
aAddRow(@xaClasses, [TRAYICO.TrayIcoCtrl.1])
aAddRow(@xaClasses, [Excel.Application])
*aAddRow(@xaClasses, [InternetExplorer.Application])
aAddRow(@xaClasses, [Outlook.Application])
*aAddRow(@xaClasses, [Com.Sun.Star.ServiceManager.1])
*aAddRow(@xaClasses, [WINFAX.SDKSEND8.0])
aAddRow(@xaClasses, [SAWZip.Archive.1])
*aAddRow(@xaClasses, [Word.Application])
*aAddRow(@xaClasses, [cdo.message])
*aAddRow(@xaClasses, [ADODB.Connection])
*aAddRow(@xaClasses, [PDF.PdfCtrl.5])
*aAddRow(@xaClasses, [msoutl.outline])
*aAddRow(@xaClasses, [MSComDlg.CommonDialog.1])
*aAddRow(@xaClasses, [MSComctlLib.ProgCtrl.2])		&& Progress Bar
*aAddRow(@xaClasses, [RICHTEXT.RichtextCtrl.1])
aAddRow(@xaClasses, [])
xcMsg=CheckClassesRegistration(@xaClasses)
xcMsg=xcMsg+iif(file([zlib.dll]), [], chr(10)+[zlib.dll not found])
IF .not.empty(xcMsg)
	MessageBox(mcERR02+xcMsg, 16, cProgram)
	Logging(mcERR02+xcMsg)
	store .F. to lQuitOutlookOnExit, lQuitExcelOnExit
	quit
ENDIF
release xcMsg, xaClasses
ENDIF


gnLeft=0					&& saved Variables
gnTop=0
glRunExcel=.T.
store [] to gcInputFile, gcInputDir, gcOutputFile
glHeading = .F.

store olFolderContacts to gnTargetFolder
store olContactItem to gnCreateItem
store "gaMapContact" to gcMapArrayName

*** definice a prvotn naplnn mapovacch tabulek
public array gaMapContact[1, 3], gaMapMail(1, 3), gaMapTask(1, 3)
aFillRow(@gaMapContact, 1, 1, [FirstName], "C")		&& XLScolumn, PropertyName, Typ
aAddRow(@gaMapContact, 2, [MiddleName], "C")
aAddRow(@gaMapContact, 3, [LastName], "C")
aAddRow(@gaMapContact, 4, [BusinessTelephoneNumber], "C")

aFillRow(@gaMapMail, 01, 1, "Recipients", "OC")
aFillRow(@gaMapMail, 99, 2, "Subject", "C")
aFillRow(@gaMapMail, 99, 3, "Body", "C")
aFillRow(@gaMapMail, 99, 4, "Attachments", "OF")

aFillRow(@gaMapTask, 01, 1, "Body", "C")
aFillRow(@gaMapTask, 99, 2, "Subject", "C")
aFillRow(@gaMapTask, 99, 3, "DueDate", "D")

If file(cCfgFile)                       && config file (all g* variables saved)
  restore from (cCfgFile) additive
endif
save all like g* to (cCfgFile)



store 1 to nXLScolumn
store [] to cOutlookField, cFieldType
public array aSheets[1]
store [] to aSheets
cActiveSheet=[]

*****	Otevreni Outlooku
lQuitOutlookOnExit=.T.
oOutlook=GetObject(,[Outlook.Application])		&& zkusim, zda uz nebezi
IF lErr1426
	oOutlook = NewObject([Outlook.Application])
	IF lErr1923		&& Outlook neni k dispozici
		Logging("ERR MS Outlook not found")
		MessageBox("MS Outlook not found", 16, cProgram)
		RETURN 3
	ELSE
		Logging("MS Outlook started")
		lQuitOutlookOnExit=.T.
	ENDIF
ELSE		&& Outlook uz bezi
	Logging("MS Outlook found running")
	lQuitOutlookOnExit=.F.
ENDIF
*****	Otevreni Excelu
store .F. to lErr1426, lErr1923
lQuitExcelOnExit=.T.
oExcel = CreateObject([Excel.Application])
IF lErr1923		&& Excel neni k dispozici
	Logging("ERR MS Excel not found")
	MessageBox("MS Excel not found", 16, cProgram)
	RETURN 3
ELSE
	Logging("MS Excel started")
	lQuitExcelOnExit=.T.
ENDIF


public array aOutlookFolders(1, 2)
aFillRow(@aOutlookFolders, 01, "Contacts", 10)	&& olFolderContacts 
aFillRow(@aOutlookFolders, 99, "Outbox", 4)			&& olFolderOutbox 
aFillRow(@aOutlookFolders, 99, "Tasks", 13)			&& olFolderTasks

cTargetFolderName=aOutlookFolders(1, 1)

*** data types:
*	C		character
*	N		numeric
* D		date	dd.mm.rrrr	dd.mm.rr
* T		datetime dd.mm.rrrr hh:mm:ss
* L		logical		other than "T, true, Y, yes, 1" = false
* OC	object character - collection of strings 
* OF	object files - collection of files

dimension aContactFields[1, 2]
aFillRow(@aContactFields, 01, [Account], "C")	&& D
aFillRow(@aContactFields, 99, [Anniversary], "D")	&& D
aAddRow(@aContactFields, [AssistantName], "C")	&& C
aAddRow(@aContactFields, [AssistantTelephoneNumber], "C")	&& C
aAddRow(@aContactFields, [Attachments], "OF")
aAddRow(@aContactFields, [BillingInformation], "C")				&& C
aAddRow(@aContactFields, [Birthday], "D")									&& D
aAddRow(@aContactFields, [Body], "C")
aAddRow(@aContactFields, [Business2TelephoneNumber], "C")	&& C
aAddRow(@aContactFields, [BusinessAddress], "C")						&& C
aAddRow(@aContactFields, [BusinessAddressCity], "C")				&& C
aAddRow(@aContactFields, [BusinessAddressCountry], "C")		&& C
aAddRow(@aContactFields, [BusinessAddressPostalCode], "C")	&& C
aAddRow(@aContactFields, [BusinessAddressPostOfficeBox], "C")	&& C
aAddRow(@aContactFields, [BusinessAddressState], "C")
aAddRow(@aContactFields, [BusinessAddressStreet], "C")
aAddRow(@aContactFields, [BusinessFaxNumber], "C")
aAddRow(@aContactFields, [BusinessHomePage], "C")
aAddRow(@aContactFields, [BusinessTelephoneNumber], "C")
aAddRow(@aContactFields, [CallbackTelephoneNumber], "C")
aAddRow(@aContactFields, [CarTelephoneNumber], "C")
aAddRow(@aContactFields, [Companies], "C")
aAddRow(@aContactFields, [CompanyMainTelephoneNumber], "C")
aAddRow(@aContactFields, [CompanyName], "C")
aAddRow(@aContactFields, [ComputerNetworkName], "C")
aAddRow(@aContactFields, [CustomerID], "C")
aAddRow(@aContactFields, [Department], "C")
aAddRow(@aContactFields, [Email1Address], "C")
aAddRow(@aContactFields, [Email1AddressType], "C")	&& the address type (such as EX or SMTP) of the first e-mail entry for the contact
*aAddRow(@aContactFields, [Email1DisplayName])
aAddRow(@aContactFields, [Email2Address], "C")
aAddRow(@aContactFields, [Email2AddressType], "C")
*aAddRow(@aContactFields, [Email2DisplayName])
aAddRow(@aContactFields, [Email3Address], "C")
aAddRow(@aContactFields, [Email3AddressType], "C")
aAddRow(@aContactFields, [FileAs], "C")
aAddRow(@aContactFields, [FirstName], "C")
aAddRow(@aContactFields, [FTPSite], "C")
aAddRow(@aContactFields, [FullName], "C")
aAddRow(@aContactFields, [Gender], "N")	&& olFemale(1), olMale(2), or olUnspecified(0
aAddRow(@aContactFields, [GovernmentIDNumber], "C")
aAddRow(@aContactFields, [Hobby], "C")
aAddRow(@aContactFields, [HomeAddress], "C")
aAddRow(@aContactFields, [HomeAddressCity], "C")
aAddRow(@aContactFields, [HomeAddressCountry], "C")
aAddRow(@aContactFields, [HomeAddressPostalCode], "C")	&& C
aAddRow(@aContactFields, [HomeAddressPostOfficeBox], "C")	&& C
aAddRow(@aContactFields, [HomeAddressState], "C")
aAddRow(@aContactFields, [HomeAddressStreet], "C")
aAddRow(@aContactFields, [HomeFaxNumber], "C")
aAddRow(@aContactFields, [HomeTelephoneNumber], "C")
aAddRow(@aContactFields, [Home2TelephoneNumber], "C")
aAddRow(@aContactFields, [Children], "C")
aAddRow(@aContactFields, [Importance], "N")	&& olImportanceHigh(2), olImportanceLow(0), or olImportanceNormal(1). 
aAddRow(@aContactFields, [Initials], "C")
aAddRow(@aContactFields, [InternetFreeBusyAddress], "C")
aAddRow(@aContactFields, [ISDNNumber], "C")
aAddRow(@aContactFields, [JobTitle], "C")
aAddRow(@aContactFields, [Language], "C")
aAddRow(@aContactFields, [LastName], "C")
aAddRow(@aContactFields, [MailingAddress], "C")
aAddRow(@aContactFields, [MailingAddressCity], "C")
aAddRow(@aContactFields, [MailingAddressCountry], "C")
aAddRow(@aContactFields, [MailingAddressPostalCode], "C")	&& C
aAddRow(@aContactFields, [MailingAddressPostOfficeBox], "C")	&& C
aAddRow(@aContactFields, [MailingAddressState], "C")
aAddRow(@aContactFields, [MailingAddressStreet], "C")
aAddRow(@aContactFields, [ManagerName], "C")
aAddRow(@aContactFields, [MiddleName], "C")
aAddRow(@aContactFields, [Mileage], "C")
aAddRow(@aContactFields, [MobileTelephoneNumber], "C")
aAddRow(@aContactFields, [NetMeetingAlias], "C")
aAddRow(@aContactFields, [NetMeetingServer], "C")
aAddRow(@aContactFields, [Nickname], "C")
aAddRow(@aContactFields, [NoAging], "L")
aAddRow(@aContactFields, [OfficeLocation], "C")
aAddRow(@aContactFields, [OrganizationalIDNumber], "C")
aAddRow(@aContactFields, [OtherAddress], "C")
aAddRow(@aContactFields, [OtherAddressCity], "C")
aAddRow(@aContactFields, [OtherAddressCountry], "C")
aAddRow(@aContactFields, [OtherAddressPostalCode], "C")	&& C
aAddRow(@aContactFields, [OtherAddressPostOfficeBox], "C")	&& C
aAddRow(@aContactFields, [OtherAddressState], "C")
aAddRow(@aContactFields, [OtherAddressStreet], "C")
aAddRow(@aContactFields, [OtherFaxNumber], "C")
aAddRow(@aContactFields, [OtherTelephoneNumber], "C")
aAddRow(@aContactFields, [PagerNumber], "C")
aAddRow(@aContactFields, [PersonalHomePage], "C")
aAddRow(@aContactFields, [PrimaryTelephoneNumber], "C")
aAddRow(@aContactFields, [Profession], "C")
aAddRow(@aContactFields, [RadioTelephoneNumber], "C")
aAddRow(@aContactFields, [ReferredBy], "C")
aAddRow(@aContactFields, [SelectedMailingAddress], "N")	&& olBusiness(2), olHome(1), olNone(0), or olOther(3)
aAddRow(@aContactFields, [Spouse], "C")
aAddRow(@aContactFields, [Subject], "C")
aAddRow(@aContactFields, [Suffix], "C")
aAddRow(@aContactFields, [TelexNumber], "C")
aAddRow(@aContactFields, [Title], "C")
aAddRow(@aContactFields, [TTYTDDTelephoneNumber], "C")
aAddRow(@aContactFields, [UnRead], "L")
aAddRow(@aContactFields, [User1], "C")
aAddRow(@aContactFields, [User2], "C")
aAddRow(@aContactFields, [User3], "C")
aAddRow(@aContactFields, [User4], "C")
aAddRow(@aContactFields, [UserCertificate], "C")
aAddRow(@aContactFields, [WebPage], "C")
* aAddRow(@aContactFields, [], "")

dimension aMailFields(1, 2)
aFillRow(@aMailFields, 001, "Attachments", "OF")	&&  Add(filename)
aFillRow(@aMailFields, 999, "BCC", "C")
aFillRow(@aMailFields, 999, "Body", "C")
aFillRow(@aMailFields, 999, "Categories", "C")
aFillRow(@aMailFields, 999, "CC", "C")
aFillRow(@aMailFields, 999, "Companies", "C")
aFillRow(@aMailFields, 999, "HTMLBody", "C")
aFillRow(@aMailFields, 999, "Recipients", "OC")		&&  Add("mailadr")
aFillRow(@aMailFields, 999, "Subject", "C")
*aFillRow(@aMailFields, 999, "")

dimension aTaskFields(1, 2)
aFillRow(@aTaskFields, 001, "Actualwork", "N")	&& N (minutes)
aFillRow(@aTaskFields, 999, "Attachments", "OF")	&&  Add(filename)
aFillRow(@aTaskFields, 999, "Body", "C")
aFillRow(@aTaskFields, 999, "CardData", "C")
aFillRow(@aTaskFields, 999, "Categories", "C")
aFillRow(@aTaskFields, 999, "Companies", "C")
aFillRow(@aTaskFields, 999, "Complete", "L")
aFillRow(@aTaskFields, 999, "DateCompleted", "D")
aFillRow(@aTaskFields, 999, "DueDate", "D")
aFillRow(@aTaskFields, 999, "Importance", "N")	&& 0, 1, 2
aFillRow(@aTaskFields, 999, "Mileage", "C")
aFillRow(@aTaskFields, 999, "NoAging", "L")
aFillRow(@aTaskFields, 999, "Ordinal", "N")
aFillRow(@aTaskFields, 999, "Owner", "C")
aFillRow(@aTaskFields, 999, "PercentComplete", "N")	&& 0..100
aFillRow(@aTaskFields, 999, "ReminderPlaySound", "L")
aFillRow(@aTaskFields, 999, "ReminderSet", "L")
aFillRow(@aTaskFields, 999, "ReminderTime", "T")	&& datetime
aFillRow(@aTaskFields, 999, "Role", "C")
aFillRow(@aTaskFields, 999, "SchedulePlusPriority", "C")	&& Can be 1 through 9, A through Z, or A1 through Z9. Priority 1 is the highest
aFillRow(@aTaskFields, 999, "StartDate", "D")
aFillRow(@aTaskFields, 999, "Status", "N")	&& olTaskComplete(2), olTaskDeferred(4), olTaskInProgress(1), olTaskNotStarted(0), or olTaskWaiting(3)
aFillRow(@aTaskFields, 999, "Subject", "C")
aFillRow(@aTaskFields, 999, "TeamTask", "L")
aFillRow(@aTaskFields, 999, "TotalWork", "N")	&& minutes?
aFillRow(@aTaskFields, 999, "UnRead", "L")
* aFillRow(@aTaskFields, 999, "", "")

gnHelpContextId=2
lMainCyklus=.T.


frmWait.Release()
DO WHILE lMainCyklus
  lMainCyklus=.F.

  DO FORM Xls2Outl NAME frmXls2Outl
  READ EVENTS

ENDDO

QUIT

*****                   UP                      *****

*****

FUNCTION ProgramShutdown()
ON SHUTDOWN
clear events
IF 	lQuitExcelOnExit
	oExcel.quit()
	Logging("MS Excel quitted")
ENDIF
IF lQuitOutlookOnExit
	oOutlook.quit()
	Logging("MS Outlook quitted")
ENDIF
Logging("END")
close all
GetNewTmp([Delete])
save all like g* to (cCfgFile)
quit
RETURN .T.



*****

FUNCTION Durchfuehren(cP)
private all like x*

* Logging("DBG: folder ", gnTargetFolder, " item: ", gnCreateItem)

xoNameSpace = oOutlook.GetNameSpace([MAPI])
xoFolder = xoNameSpace.GetDefaultFolder(gnTargetFolder)		&& adresar Outlooku
Logging([XLS table: <]+gcInputFile+[> sheet: <]+cActiveSheet+[> open])
xnAdded=0
xnLenMap=ALen(&gcMapArrayName, 1)
WITH oExcel
	.Sheets(cActiveSheet).Select()
  xnLastCol=.ActiveCell.SpecialCells(11).Column
  xnLastRow=.ActiveCell.SpecialCells(11).Row
  dimension xaRow[xnLastCol]		&& pomocne pole XLS hodnot
	FOR xnI=iif(glHeading, 2, 1) to xnLastRow
		xcRow=[]			&& skip empty rows
		For xnJ=1 to xnLastCol		&& nacteni XLS radku do pole
			xaRow[xnJ]=Alltrim(Transform(.ActiveSheet.Cells(xnI, xnJ).Value))
			xcRow=xcRow+xaRow[xnJ]
		EndFor
		If empty(xcRow)
			loop
		EndIf
		xoItem=oOutlook.CreateItem(gnCreateItem)
		xnAdded=xnAdded+1
		For xnJ=1 to xnLenMap
			xcCF= &gcMapArrayName [xnJ, 2]		&& target contact field
			xnXC= &gcMapArrayName [xnJ, 1]		&& XLS column index
			xcTyp=&gcMapArrayName [xnJ, 3]		&& fieldtyp
			If between(xnXC, 1, xnLastCol)
				xxValue=xaRow[xnXC]		&& XLS column value
				if .not.empty(xxValue)
					xxValue=Rtrim(Transform(xxValue))
					DO CASE
						CASE xcTyp="C"		&& string
							xoItem.&xcCF. =xxValue
						CASE xcTyp="N"		&& numeric
							xoItem.&xcCF. =val(xxValue)
						CASE xcTyp="D"		&& date
							xoItem.&xcCF. =CtoD(xxValue)
						CASE xcTyp="T"		&& datetime
							xoItem.&xcCF. =CtoT(xxValue)
						CASE xcTyp="L"		&& logical
							xoItem.&xcCF. =inlist( Upper(xxValue), "T", "Y", "TRUE", "YES", "1", ".T.", "PRAVDA" )
						CASE xcTyp="OC"		&& colection - string
							xoItem.&xcCF..Add(xxValue)
						CASE xcTyp="OF"		&& colection - file
							if file(xxValue)
								xoItem.&xcCF..Add(FullPath(xxValue))
							endif
					ENDCASE

				endif
			EndIf
		EndFor
		xoItem.Save()
		frmXls2Outl.ProgressBar.Value=int(xnI/xnLastRow*100)
	ENDFOR	
	.workbooks.close()
ENDWITH
Logging([Import finished, ], xnAdded, [ items added into ], cTargetFolderName)
RETURN .T.

***** never run

myEscape()
ErrTrap()
CSoff()
*****

